(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common/http'), require('rxjs/operators'), require('rxjs'), require('@monabbous/unflatter'), require('lodash'), require('@monabbous/object-digger')) :
    typeof define === 'function' && define.amd ? define('@monabbous/ng-api-wrapper', ['exports', '@angular/core', '@angular/common/http', 'rxjs/operators', 'rxjs', '@monabbous/unflatter', 'lodash', '@monabbous/object-digger'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.monabbous = global.monabbous || {}, global.monabbous['ng-api-wrapper'] = {}), global.ng.core, global.ng.common.http, global.rxjs.operators, global.rxjs, global.unflatter, global.lodash, global.objectDigger));
}(this, (function (exports, i0, i1, operators, rxjs, unflatter, lodash, objectDigger) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from) {
        for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
            to[j] = from[i];
        return to;
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var API_CONFIG = new i0.InjectionToken('APIConfig');
    // @dynamic
    var NgApiWrapperService = /** @class */ (function () {
        function NgApiWrapperService(http, apiConfig) {
            this.http = http;
            this.apiConfig = apiConfig;
            console.log(apiConfig);
        }
        NgApiWrapperService.jsonToFormData = function (object) {
            return __awaiter(this, void 0, void 0, function () {
                var formData, worthConverting, append;
                var _this = this;
                return __generator(this, function (_d) {
                    switch (_d.label) {
                        case 0:
                            if (object instanceof FormData) {
                                return [2 /*return*/, object];
                            }
                            formData = new FormData();
                            worthConverting = false;
                            append = function (data, keys) {
                                if (keys === void 0) { keys = []; }
                                return __awaiter(_this, void 0, void 0, function () {
                                    var _this = this;
                                    return __generator(this, function (_d) {
                                        switch (_d.label) {
                                            case 0: return [4 /*yield*/, new Promise(function (res) { return __awaiter(_this, void 0, void 0, function () {
                                                    var _d, _e, key, item, itemKey, e_1_1;
                                                    var e_1, _f;
                                                    return __generator(this, function (_g) {
                                                        switch (_g.label) {
                                                            case 0:
                                                                _g.trys.push([0, 7, 8, 9]);
                                                                _d = __values(Object.keys(data)), _e = _d.next();
                                                                _g.label = 1;
                                                            case 1:
                                                                if (!!_e.done) return [3 /*break*/, 6];
                                                                key = _e.value;
                                                                if (key === 'isFormArray') {
                                                                    delete data[key];
                                                                    return [3 /*break*/, 5];
                                                                }
                                                                item = data[key];
                                                                itemKey = __spread(keys, [key]).map(function (k, i) { return i > 0 ? "[" + k + "]" : k; }).join('');
                                                                if (!(item instanceof Blob)) return [3 /*break*/, 2];
                                                                formData.append(itemKey, item);
                                                                worthConverting = true;
                                                                return [3 /*break*/, 5];
                                                            case 2:
                                                                if (!((Array.isArray(item) || (typeof item === 'object')) && item !== null && item !== undefined)) return [3 /*break*/, 4];
                                                                return [4 /*yield*/, append(item, __spread(keys, [key]))];
                                                            case 3:
                                                                _g.sent();
                                                                return [3 /*break*/, 5];
                                                            case 4:
                                                                formData.append(itemKey, item);
                                                                _g.label = 5;
                                                            case 5:
                                                                _e = _d.next();
                                                                return [3 /*break*/, 1];
                                                            case 6: return [3 /*break*/, 9];
                                                            case 7:
                                                                e_1_1 = _g.sent();
                                                                e_1 = { error: e_1_1 };
                                                                return [3 /*break*/, 9];
                                                            case 8:
                                                                try {
                                                                    if (_e && !_e.done && (_f = _d.return)) _f.call(_d);
                                                                }
                                                                finally { if (e_1) throw e_1.error; }
                                                                return [7 /*endfinally*/];
                                                            case 9:
                                                                res(formData);
                                                                return [2 /*return*/];
                                                        }
                                                    });
                                                }); })];
                                            case 1: return [2 /*return*/, _d.sent()];
                                        }
                                    });
                                });
                            };
                            return [4 /*yield*/, append(object)];
                        case 1:
                            _d.sent();
                            return [2 /*return*/, worthConverting ? formData : object];
                    }
                });
            });
        };
        NgApiWrapperService.prototype.getFullUrl = function (server, version) {
            var _a, _b;
            return ((_a = this.apiConfig.servers[server]) === null || _a === void 0 ? void 0 : _a.baseUrl) + ((_b = this.apiConfig.servers[server]) === null || _b === void 0 ? void 0 : _b.versions[version]);
        };
        NgApiWrapperService.prototype.handleServer = function (server) {
            if (!Object.keys(this.apiConfig.servers).includes(server)) {
                console.warn("Ng Api Wrapper: Server '" + server + "' is not in the configuration, will use the defaultServer");
                server = this.apiConfig.defaultServer;
            }
            return server;
        };
        NgApiWrapperService.prototype.handleServerVersion = function (server, version) {
            var _a;
            if (!Object.keys(this.apiConfig.servers[server].versions).includes(version)) {
                console.warn("Ng Api Wrapper: Server '" + server + "' Api version '" + version + "' is not in the configuration, will use the defaultVersion");
                version = (_a = this.apiConfig.servers[server]) === null || _a === void 0 ? void 0 : _a.defaultVersion;
            }
            return version;
        };
        NgApiWrapperService.prototype.handleResponse = function (request, parameters) {
            var _this = this;
            return request
                .pipe(operators.switchMap(function (response) { return _this.apiConfig.onSuccess ? _this.apiConfig.onSuccess(response, parameters) : rxjs.of(response); }), operators.catchError(function (response) { return _this.apiConfig.onError ? _this.apiConfig.onError(response, parameters) : rxjs.throwError(response); }));
        };
        NgApiWrapperService.prototype.get = function (request) {
            var _this = this;
            var _a, _b, _c;
            var next = function (req) {
                var _a;
                var _d = req.body, body = _d === void 0 ? {} : _d, version = req.version, server = req.server;
                var path = req.path, outsource = req.outsource, _e = req.options, options = _e === void 0 ? {} : _e;
                server = _this.handleServer(server);
                version = _this.handleServerVersion(server, version);
                body = unflatter.unflatter(body);
                var params = Object.assign({}, body);
                delete params._method;
                options.params = body ? new i1.HttpParams({ fromObject: params }) : options.params;
                // @ts-ignore
                var method = function () {
                    var _d;
                    var a = [];
                    for (var _i = 0; _i < arguments.length; _i++) {
                        a[_i] = arguments[_i];
                    }
                    return (_d = _this.http).get.apply(_d, __spread(a));
                };
                var args = [(outsource ? '' : _this.getFullUrl(server, version)) + path, options];
                if ((_a = _this.apiConfig) === null || _a === void 0 ? void 0 : _a.methodOverride) {
                    // @ts-ignore
                    method = function () {
                        var _d;
                        var a = [];
                        for (var _i = 0; _i < arguments.length; _i++) {
                            a[_i] = arguments[_i];
                        }
                        return (_d = _this.http).post.apply(_d, __spread(a));
                    };
                    args = [(outsource ? '' : _this.getFullUrl(server, version)) + path, Object.assign({ _method: 'GET' }, body), options];
                }
                return rxjs.from(NgApiWrapperService.jsonToFormData(body))
                    .pipe(operators.mergeMap(function (b) {
                    body = b;
                    // @ts-ignore
                    return _this.handleResponse(method.apply(void 0, __spread(args)), {
                        baseUrl: _this.getFullUrl(server, version),
                        path: path,
                        outsource: outsource,
                        body: body,
                        server: server,
                        version: version,
                        options: options,
                        method: 'GET'
                    });
                }));
            };
            return (_c = (_b = (_a = this.apiConfig) === null || _a === void 0 ? void 0 : _a.intercept) === null || _b === void 0 ? void 0 : _b.call(_a, request, next)) !== null && _c !== void 0 ? _c : next(request);
        };
        NgApiWrapperService.prototype.post = function (request) {
            var _this = this;
            var _a, _b, _c;
            var next = function (req) {
                var _d = req.body, body = _d === void 0 ? {} : _d, version = req.version, server = req.server;
                var path = req.path, outsource = req.outsource, _e = req.options, options = _e === void 0 ? {} : _e;
                server = _this.handleServer(server);
                version = _this.handleServerVersion(server, version);
                body = unflatter.unflatter(body);
                return rxjs.from(NgApiWrapperService.jsonToFormData(body))
                    .pipe(operators.mergeMap(function (b) {
                    body = b;
                    // @ts-ignore
                    return _this.handleResponse(_this.http.post(
                    // @ts-ignore
                    (outsource ? '' : _this.getFullUrl(server, version)) + path, body, options), {
                        baseUrl: _this.getFullUrl(server, version),
                        path: path,
                        outsource: outsource,
                        body: body,
                        server: server,
                        version: version,
                        options: options,
                        method: 'POST'
                    });
                }));
            };
            return (_c = (_b = (_a = this.apiConfig) === null || _a === void 0 ? void 0 : _a.intercept) === null || _b === void 0 ? void 0 : _b.call(_a, request, next)) !== null && _c !== void 0 ? _c : next(request);
        };
        NgApiWrapperService.prototype.patch = function (request) {
            var _this = this;
            var _a, _b, _c;
            var next = function (req) {
                var _a;
                var _d = req.body, body = _d === void 0 ? {} : _d, version = req.version, server = req.server;
                var path = req.path, outsource = req.outsource, _e = req.options, options = _e === void 0 ? {} : _e;
                server = _this.handleServer(server);
                version = _this.handleServerVersion(server, version);
                body = unflatter.unflatter(body);
                // @ts-ignore
                var method = function () {
                    var _d;
                    var a = [];
                    for (var _i = 0; _i < arguments.length; _i++) {
                        a[_i] = arguments[_i];
                    }
                    return (_d = _this.http).patch.apply(_d, __spread(a));
                };
                var args = [(outsource ? '' : _this.getFullUrl(server, version)) + path, body, options];
                if ((_a = _this.apiConfig) === null || _a === void 0 ? void 0 : _a.methodOverride) {
                    // @ts-ignore
                    method = function () {
                        var _d;
                        var a = [];
                        for (var _i = 0; _i < arguments.length; _i++) {
                            a[_i] = arguments[_i];
                        }
                        return (_d = _this.http).post.apply(_d, __spread(a));
                    };
                    args = [(outsource ? '' : _this.getFullUrl(server, version)) + path, Object.assign({ _method: 'PATCH' }, body), options];
                }
                return rxjs.from(NgApiWrapperService.jsonToFormData(body))
                    .pipe(operators.mergeMap(function (b) {
                    body = b;
                    // @ts-ignore
                    return _this.handleResponse(method.apply(void 0, __spread(args)), {
                        baseUrl: _this.getFullUrl(server, version),
                        path: path,
                        outsource: outsource,
                        body: body,
                        server: server,
                        version: version,
                        options: options,
                        method: 'PATCH'
                    });
                }));
            };
            return (_c = (_b = (_a = this.apiConfig) === null || _a === void 0 ? void 0 : _a.intercept) === null || _b === void 0 ? void 0 : _b.call(_a, request, next)) !== null && _c !== void 0 ? _c : next(request);
        };
        NgApiWrapperService.prototype.put = function (request) {
            var _this = this;
            var _a, _b, _c;
            var next = function (req) {
                var _a;
                var _d = req.body, body = _d === void 0 ? {} : _d, version = req.version, server = req.server;
                var path = req.path, outsource = req.outsource, _e = req.options, options = _e === void 0 ? {} : _e;
                server = _this.handleServer(server);
                version = _this.handleServerVersion(server, version);
                body = unflatter.unflatter(body);
                // @ts-ignore
                var method = function () {
                    var _d;
                    var a = [];
                    for (var _i = 0; _i < arguments.length; _i++) {
                        a[_i] = arguments[_i];
                    }
                    return (_d = _this.http).put.apply(_d, __spread(a));
                };
                var args = [(outsource ? '' : _this.getFullUrl(server, version)) + path, body, options];
                if ((_a = _this.apiConfig) === null || _a === void 0 ? void 0 : _a.methodOverride) {
                    // @ts-ignore
                    method = function () {
                        var _d;
                        var a = [];
                        for (var _i = 0; _i < arguments.length; _i++) {
                            a[_i] = arguments[_i];
                        }
                        return (_d = _this.http).post.apply(_d, __spread(a));
                    };
                    args = [(outsource ? '' : _this.getFullUrl(server, version)) + path, Object.assign({ _method: 'PUT' }, body), options];
                }
                return rxjs.from(NgApiWrapperService.jsonToFormData(body))
                    .pipe(operators.mergeMap(function (b) {
                    body = b;
                    // @ts-ignore
                    return _this.handleResponse(method.apply(void 0, __spread(args)), {
                        baseUrl: _this.getFullUrl(server, version),
                        path: path,
                        outsource: outsource,
                        body: body,
                        server: server,
                        version: version,
                        options: options,
                        method: 'PUT'
                    });
                }));
            };
            return (_c = (_b = (_a = this.apiConfig) === null || _a === void 0 ? void 0 : _a.intercept) === null || _b === void 0 ? void 0 : _b.call(_a, request, next)) !== null && _c !== void 0 ? _c : next(request);
        };
        NgApiWrapperService.prototype.delete = function (request) {
            var _this = this;
            var _a, _b, _c;
            var next = function (req) {
                var _a;
                var _d = req.body, body = _d === void 0 ? {} : _d, version = req.version, server = req.server;
                var path = req.path, outsource = req.outsource, _e = req.options, options = _e === void 0 ? {} : _e;
                server = _this.handleServer(server);
                version = _this.handleServerVersion(server, version);
                body = unflatter.unflatter(body);
                // @ts-ignore
                var method = function () {
                    var _d;
                    var a = [];
                    for (var _i = 0; _i < arguments.length; _i++) {
                        a[_i] = arguments[_i];
                    }
                    return (_d = _this.http).delete.apply(_d, __spread(a));
                };
                var args = [(outsource ? '' : _this.getFullUrl(server, version)) + path, body, options];
                if ((_a = _this.apiConfig) === null || _a === void 0 ? void 0 : _a.methodOverride) {
                    // @ts-ignore
                    method = function () {
                        var _d;
                        var a = [];
                        for (var _i = 0; _i < arguments.length; _i++) {
                            a[_i] = arguments[_i];
                        }
                        return (_d = _this.http).post.apply(_d, __spread(a));
                    };
                    args = [(outsource ? '' : _this.getFullUrl(server, version)) + path, Object.assign({ _method: 'DELETE' }, body), options];
                }
                return rxjs.from(NgApiWrapperService.jsonToFormData(body))
                    .pipe(operators.mergeMap(function (b) {
                    body = b;
                    // @ts-ignore
                    return _this.handleResponse(method.apply(void 0, __spread(args)), {
                        baseUrl: _this.getFullUrl(server, version),
                        path: path,
                        outsource: outsource,
                        body: body,
                        server: server,
                        version: version,
                        options: options,
                        method: 'DELETE'
                    });
                }));
            };
            return (_c = (_b = (_a = this.apiConfig) === null || _a === void 0 ? void 0 : _a.intercept) === null || _b === void 0 ? void 0 : _b.call(_a, request, next)) !== null && _c !== void 0 ? _c : next(request);
        };
        return NgApiWrapperService;
    }());
    NgApiWrapperService.ɵprov = i0.ɵɵdefineInjectable({ factory: function NgApiWrapperService_Factory() { return new NgApiWrapperService(i0.ɵɵinject(i1.HttpClient), i0.ɵɵinject(API_CONFIG)); }, token: NgApiWrapperService, providedIn: "root" });
    NgApiWrapperService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    NgApiWrapperService.ctorParameters = function () { return [
        { type: i1.HttpClient },
        { type: undefined, decorators: [{ type: i0.Inject, args: [API_CONFIG,] }] }
    ]; };

    // @dynamic
    var NgApiWrapperModule = /** @class */ (function () {
        function NgApiWrapperModule() {
        }
        NgApiWrapperModule.forRoot = function (apiConfig) {
            return {
                ngModule: NgApiWrapperModule,
                providers: [
                    { provide: API_CONFIG, useValue: apiConfig }
                ]
            };
        };
        return NgApiWrapperModule;
    }());
    NgApiWrapperModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [],
                    imports: [i1.HttpClientModule],
                    exports: [],
                    providers: [
                        NgApiWrapperService,
                    ]
                },] }
    ];

    function smartResourcePageRefresh(unique) {
        if (unique === void 0) { unique = 'id'; }
        return operators.distinctUntilChanged(function (pre, cur) {
            var e_1, _h;
            var _a, _b, _c, _d;
            var preData = pre.data;
            var curData = cur.data;
            if (curData.length !== preData.length) {
                return false;
            }
            if (cur.meta && cur.meta && ((_a = cur.meta) === null || _a === void 0 ? void 0 : _a.pagination)
                && pre.meta && pre.meta && ((_b = pre.meta) === null || _b === void 0 ? void 0 : _b.pagination)
                && ((_c = pre.meta) === null || _c === void 0 ? void 0 : _c.pagination.current_page) !== ((_d = cur.meta) === null || _d === void 0 ? void 0 : _d.pagination.current_page)) {
                return false;
            }
            var _loop_1 = function (datum) {
                var newDatum = curData.find(function (d) { return (objectDigger.digger(unique, d) || []).pop() === (objectDigger.digger(unique, datum) || []).pop(); });
                if (!newDatum) {
                    return { value: false };
                }
                if (!lodash.isEqual(datum, newDatum)) {
                    Object.assign(datum, newDatum);
                }
            };
            try {
                for (var preData_1 = __values(preData), preData_1_1 = preData_1.next(); !preData_1_1.done; preData_1_1 = preData_1.next()) {
                    var datum = preData_1_1.value;
                    var state_1 = _loop_1(datum);
                    if (typeof state_1 === "object")
                        return state_1.value;
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (preData_1_1 && !preData_1_1.done && (_h = preData_1.return)) _h.call(preData_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return true;
        });
    }
    var NgApiResourceService = /** @class */ (function () {
        function NgApiResourceService(http) {
            this.http = http;
            this.resourceName = '';
            this.parentPrefix = '';
            this.params = {};
            this.filters = {};
            this.sort_order = 'asc';
            this.adapters = {};
            this.cachedModel$ = new rxjs.BehaviorSubject(null);
            this.refresher$ = new rxjs.BehaviorSubject(null);
            this.loadmore$ = new rxjs.BehaviorSubject(null);
            this.lastPage = false;
        }
        NgApiResourceService.prototype.getResourcePath = function (operation, body, id) {
            return ['get', 'create'].includes(operation) ?
                this.resourceName : this.resourceName + "/" + id;
        };
        NgApiResourceService.prototype.getParentPrefix = function (operation, body) {
            return this.parentPrefix;
        };
        NgApiResourceService.prototype.getDefaultServer = function (operation, body) {
            return this.defaultServer;
        };
        NgApiResourceService.prototype.getDefaultVersion = function (operation, body) {
            return this.defaultVersion;
        };
        NgApiResourceService.prototype.downAdapt = function (data) {
            var e_2, _h;
            var _this = this;
            var _loop_2 = function (key) {
                if (!this_1.adapters[key].down) {
                    return "continue";
                }
                var keys = key.split(/\[\s*([\w]+)\s*]/g)
                    .filter(function (f) { return f !== ''; });
                keys.reduce(function (pointer, k, i) {
                    if (![null, undefined].includes(pointer)) {
                        if (i < keys.length - 1) {
                            return pointer[k];
                        }
                        else {
                            pointer[k + '[adapted]'] = _this.adapters[key].down(pointer[k], data);
                        }
                    }
                    return pointer;
                }, data);
            };
            var this_1 = this;
            try {
                for (var _j = __values(Object.keys(this.adapters)), _k = _j.next(); !_k.done; _k = _j.next()) {
                    var key = _k.value;
                    _loop_2(key);
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (_k && !_k.done && (_h = _j.return)) _h.call(_j);
                }
                finally { if (e_2) throw e_2.error; }
            }
            return data;
        };
        NgApiResourceService.prototype.upAdapt = function (data, method) {
            var e_3, _h;
            var _this = this;
            var _loop_3 = function (key) {
                if (!this_2.adapters[key].up) {
                    return "continue";
                }
                var keys = key.split(/\[\s*([\w]+)\s*]/g)
                    .filter(function (f) { return f !== ''; });
                keys.reduce(function (pointer, k, i) {
                    if (pointer !== undefined) {
                        if (i < keys.length - 1) {
                            return pointer[k];
                        }
                        else {
                            pointer[k] = _this.adapters[key].up(pointer[k], data, method);
                        }
                    }
                    return pointer;
                }, data);
            };
            var this_2 = this;
            try {
                for (var _j = __values(Object.keys(this.adapters)), _k = _j.next(); !_k.done; _k = _j.next()) {
                    var key = _k.value;
                    _loop_3(key);
                }
            }
            catch (e_3_1) { e_3 = { error: e_3_1 }; }
            finally {
                try {
                    if (_k && !_k.done && (_h = _j.return)) _h.call(_j);
                }
                finally { if (e_3) throw e_3.error; }
            }
            return data;
        };
        NgApiResourceService.prototype.transformer = function (t) {
            return t;
        };
        NgApiResourceService.prototype.where = function (field, value) {
            this.filters[field] = value;
            return this;
        };
        NgApiResourceService.prototype.setParam = function (key, value) {
            this.params[key] = value;
            return this;
        };
        NgApiResourceService.prototype.sortBy = function (field, order) {
            if (order === void 0) { order = 'asc'; }
            this.sort_by = field;
            this.sort_order = order;
            return this;
        };
        NgApiResourceService.prototype.get = function (filters) {
            var _this = this;
            if (filters === void 0) { filters = {}; }
            filters = Object.assign(Object.assign({}, this.filters), filters);
            filters = this.upAdapt(filters, 'get');
            var body = this.parseSort(this.parseFilters(this.params, filters, 'get'));
            return this.http.get({
                version: this.getDefaultVersion('get', body),
                server: this.getDefaultServer('get', body),
                path: this.getParentPrefix('get', body) + this.getResourcePath('get', body),
                body: body
            })
                .pipe(operators.map(function (resource) {
                if (!(Object.keys(resource).includes('data'))) {
                    if (Object.keys(resource).includes(_this.accessor)) {
                        // @ts-ignore
                        resource.data = resource[_this.accessor];
                        delete resource[_this.accessor];
                    }
                    else {
                        // @ts-ignore
                        resource.data = resource;
                    }
                }
                if (!(Object.keys(resource).includes('meta')
                    && Object.keys(resource.meta).includes('pagination'))
                    && Object.keys(resource).includes('current_page')) {
                    // @ts-ignore
                    resource.meta = resource.meta || {};
                }
                resource.data = resource.data.map(function (d) { return _this.downAdapt(d); });
                resource.data = resource.data.map(function (d) { return _this.transformer(d); });
                return resource;
            }));
        };
        NgApiResourceService.prototype.find = function (id) {
            var _this = this;
            var filters = this.upAdapt(this.filters, 'find');
            var body = this.parseFilters(this.params, filters, 'find');
            return this.http.get({
                version: this.getDefaultVersion('find', body),
                server: this.getDefaultServer('find', body),
                path: this.getParentPrefix('find', body) + this.getResourcePath('find', body, id),
                body: body
            })
                .pipe(operators.map(function (resource) {
                if (!('data' in resource)) {
                    // @ts-ignore
                    resource.data = resource;
                }
                resource.data = _this.downAdapt(resource.data);
                resource.data = _this.transformer(resource.data);
                return resource;
            }), operators.tap(function (model) { return _this.cachedModel$.next(model); }));
        };
        NgApiResourceService.prototype.create = function (body) {
            body = this.upAdapt(body, 'create');
            return this.http.post({
                version: this.getDefaultVersion('create', body),
                server: this.getDefaultServer('create', body),
                path: this.getParentPrefix('create', body) + this.getResourcePath('create', body),
                body: body
            });
        };
        NgApiResourceService.prototype.update = function (id, body) {
            body = this.upAdapt(body, 'update');
            return this.http.patch({
                version: this.getDefaultVersion('update', body),
                server: this.getDefaultServer('update', body),
                path: this.getParentPrefix('update', body) + this.getResourcePath('update', body, id),
                body: body
            });
        };
        NgApiResourceService.prototype.delete = function (id, body) {
            if (body === void 0) { body = {}; }
            body = this.upAdapt(body, 'delete');
            return this.http.delete({
                version: this.getDefaultVersion('delete', body),
                server: this.getDefaultServer('delete', body),
                path: this.getParentPrefix('delete', body) + this.getResourcePath('delete', body, id),
                body: body
            });
        };
        NgApiResourceService.prototype.init = function (options) {
            var _this = this;
            var pagination = null;
            var reset = true;
            this.refresher$ = (options === null || options === void 0 ? void 0 : options.refresher$) || this.refresher$;
            var checkParent = function () {
                if (!(options === null || options === void 0 ? void 0 : options.parent)) {
                    _this.parentPrefix = '';
                    return rxjs.of(null);
                }
                return options.parent.cachedModel$
                    .pipe(operators.filter(function (parent) { return !!parent; }), operators.tap(function (parent) { return _this.parentPrefix = options.parent.resourceName + '/' + parent.data.id + '/'; }));
            };
            this.page$ =
                this.refresher$
                    .pipe(operators.switchMap(checkParent), operators.switchMap(function () { var _a; return ((_a = options === null || options === void 0 ? void 0 : options.route) === null || _a === void 0 ? void 0 : _a.queryParams) || rxjs.of({}); }), operators.switchMap(function (filters) {
                    if (options === null || options === void 0 ? void 0 : options.loadmore) {
                        reset = true;
                        _this.lastPage = false;
                        pagination = null;
                        return _this.loadmore$
                            .pipe(operators.filter(function () { return !_this.lastPage; }), operators.map(function () { return (Object.assign(Object.assign({}, filters), { page: (pagination && pagination.current_page || 0) + 1 })); }));
                    }
                    return rxjs.of(filters);
                }), operators.switchMap(function (filters) {
                    var e_4, _h;
                    var _a, _b;
                    var newFilters = ((_a = options === null || options === void 0 ? void 0 : options.filters) === null || _a === void 0 ? void 0 : _a.length) ? {} : Object.assign({}, filters);
                    try {
                        for (var _j = __values(Object.keys(filters)), _k = _j.next(); !_k.done; _k = _j.next()) {
                            var key = _k.value;
                            if ((_b = options === null || options === void 0 ? void 0 : options.filters) === null || _b === void 0 ? void 0 : _b.includes(key)) {
                                newFilters[key] = filters[key];
                            }
                        }
                    }
                    catch (e_4_1) { e_4 = { error: e_4_1 }; }
                    finally {
                        try {
                            if (_k && !_k.done && (_h = _j.return)) _h.call(_j);
                        }
                        finally { if (e_4) throw e_4.error; }
                    }
                    return _this.get(newFilters);
                }), operators.tap(function (page) { var _a; return pagination = (_a = page.meta) === null || _a === void 0 ? void 0 : _a.pagination; }), operators.tap(function (page) {
                    var _a, _b, _c, _d, _e, _f;
                    return _this.lastPage =
                        Math.ceil(((_b = (_a = page === null || page === void 0 ? void 0 : page.meta) === null || _a === void 0 ? void 0 : _a.pagination) === null || _b === void 0 ? void 0 : _b.total) / ((_d = (_c = page === null || page === void 0 ? void 0 : page.meta) === null || _c === void 0 ? void 0 : _c.pagination) === null || _d === void 0 ? void 0 : _d.per_page))
                            <= ((_f = (_e = page === null || page === void 0 ? void 0 : page.meta) === null || _e === void 0 ? void 0 : _e.pagination) === null || _f === void 0 ? void 0 : _f.current_page);
                }), operators.distinctUntilChanged(function (pre, cur) {
                    var _h;
                    var _a, _b, _c, _d, _e, _f, _g;
                    if (options === null || options === void 0 ? void 0 : options.loadmore) {
                        if (reset) {
                            return false;
                        }
                        if (!((_a = cur === null || cur === void 0 ? void 0 : cur.meta) === null || _a === void 0 ? void 0 : _a.pagination)) {
                            _this.lastPage = true;
                            return false;
                        }
                        if (Math.ceil(((_c = (_b = cur === null || cur === void 0 ? void 0 : cur.meta) === null || _b === void 0 ? void 0 : _b.pagination) === null || _c === void 0 ? void 0 : _c.total) / ((_e = (_d = cur === null || cur === void 0 ? void 0 : cur.meta) === null || _d === void 0 ? void 0 : _d.pagination) === null || _e === void 0 ? void 0 : _e.per_page)) >= ((_g = (_f = cur === null || cur === void 0 ? void 0 : cur.meta) === null || _f === void 0 ? void 0 : _f.pagination) === null || _g === void 0 ? void 0 : _g.current_page)) {
                            (_h = pre.data).push.apply(_h, __spread(cur.data));
                            cur.data = pre.data;
                        }
                    }
                    return false;
                }), operators.tap(function () { return reset = false; }), smartResourcePageRefresh(options === null || options === void 0 ? void 0 : options.uniqueId));
            this.model$ =
                this.refresher$
                    .pipe(operators.switchMap(checkParent), operators.switchMap(function () { var _a; return ((_a = options === null || options === void 0 ? void 0 : options.route) === null || _a === void 0 ? void 0 : _a.params) || rxjs.of({}); }), operators.switchMap(function (params) { return _this.find(params[options === null || options === void 0 ? void 0 : options.idParameter]); }), operators.tap(function (model) { return _this.cachedModel$.next(model); }));
            return this;
        };
        NgApiResourceService.prototype.superviseRefreshers = function () {
            var _this = this;
            var services = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                services[_i] = arguments[_i];
            }
            services.forEach(function (service) { return service.refresher$ = _this.refresher$; });
            return this;
        };
        NgApiResourceService.prototype.parseFilters = function (params, filters, operation) {
            return Object.assign(Object.assign({}, params), filters);
        };
        NgApiResourceService.prototype.parseSort = function (params) {
            params.sort_by = this.sort_by;
            params.sort_order = this.sort_order;
            return params;
        };
        return NgApiResourceService;
    }());
    NgApiResourceService.ɵprov = i0.ɵɵdefineInjectable({ factory: function NgApiResourceService_Factory() { return new NgApiResourceService(i0.ɵɵinject(NgApiWrapperService)); }, token: NgApiResourceService, providedIn: "any" });
    NgApiResourceService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'any'
                },] }
    ];
    NgApiResourceService.ctorParameters = function () { return [
        { type: NgApiWrapperService }
    ]; };

    /*
     * Public API Surface of ng-api-wrapper2
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.API_CONFIG = API_CONFIG;
    exports.NgApiResourceService = NgApiResourceService;
    exports.NgApiWrapperModule = NgApiWrapperModule;
    exports.NgApiWrapperService = NgApiWrapperService;
    exports.smartResourcePageRefresh = smartResourcePageRefresh;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=monabbous-ng-api-wrapper.umd.js.map
